import re
from typing import Any, Dict, List, Text
import pyarabic.araby as araby
import json
from itertools import chain
import jellyfish  #correctionPackage"
import unicodedata
from pyarabic.unshape import unshaping_line
import arabic_reshaper
from itertools import *
from rasa.nlu.components import Component
from rasa.nlu.config import RasaNLUModelConfig
from rasa.nlu.tokenizers.tokenizer import Token, Tokenizer
from rasa.nlu.training_data import Message, TrainingData
from younes.translator_DarijaFr_DarijaAr import trans 
from rasa.nlu.constants import (
    INTENT_ATTRIBUTE,
    TEXT_ATTRIBUTE,
    TOKENS_NAMES,
    MESSAGE_ATTRIBUTES,
)

class WhitespaceTokenizer_arab_banki(Tokenizer, Component):

    provides = [TOKENS_NAMES[attribute] for attribute in MESSAGE_ATTRIBUTES]

    def unique_words(lines):
        return set(chain(*(line.split() for line in lines if line)))
    
    dict= {}
    
    
    defaults = {
        # text will be tokenized with case sensitive as default
        # Flag to check whether to split intents
        "intent_tokenization_flag": False,
        # Symbol on which intent should be split
        "intent_split_symbol": "_",
        # Text will be tokenized with case sensitive as default
        "case_sensitive": True,
        # add __CLS__ token to the end of the list of tokens
        "use_cls_token": False,
        
    }

    def __init__(self, component_config: Dict[Text, Any] = None) -> None:
        """Construct a new tokenizer using the WhitespaceTokenizer framework."""
        """Construct a new tokenizer using the WhitespaceTokenizer framework."""

        super().__init__(component_config)
        # flag to check whether to split intents
        self.intent_tokenization_flag = self.component_config.get(
            "intent_tokenization_flag"
        )
        # split symbol for intents
        self.intent_split_symbol = self.component_config["intent_split_symbol"]
        self.case_sensitive = self.component_config["case_sensitive"]

        

    def train(
           
        self, training_data: TrainingData, config: RasaNLUModelConfig, **kwargs: Any
    ) -> None:
        for example in training_data.training_examples:
            for attribute in MESSAGE_ATTRIBUTES:
                if example.get(attribute) is not None:
                    example.set(
                        TOKENS_NAMES[attribute],
                        self.tokenize_train(example.get(attribute), attribute),
                 )


    def process(self, message: Message, **kwargs: Any) -> None:
        lettre="abcdefghijklmnopqrstuvwxyz"
        for i in message.text:
            if i not in lettre:
               
               message.set(TOKENS_NAMES[TEXT_ATTRIBUTE], self.tokenize_arab(message.text))
               break
            else :
               message.set(TOKENS_NAMES[TEXT_ATTRIBUTE], self.tokenize(message.text))
               break
        

    def tokenize_train(self, text: Text, attribute: Text = TEXT_ATTRIBUTE) -> List[Token]:
    
        if not self.case_sensitive:
            text = text.lower()
        # remove 'not a word character' if
        if attribute != INTENT_ATTRIBUTE:
            words = re.sub(
            # there is a space or an end of a string after it
            r"[^\w#@&]+(?=\s|$)|"
            # there is a space or beginning of a string before it
            # not followed by a number
            r"(\s|^)[^\w#@&]+(?=[^0-9\s])|"
            # not in between numbers and not . or @ or & or - or #
            # e.g. 10'000.00 or blabla@gmail.com
            # and not url characters
            r"(?<=[^0-9\s])[^\w._~:/?#\[\]()@!$&*+,;=-]+(?=[^0-9\s])",
            " ",
               text,
            ).split()
            if not words:
                words = [text]
                
        else:
            words = (
                text.split(self.intent_split_symbol)
                if self.intent_tokenization_flag
                else [text]
            )
            
        running_offset = 0
        tokens = []
        
        for word in words:
            # corrected word is the one with the minimum distance
            word_offset = text.index(word, running_offset)
            word_len = len(word)
            running_offset = word_offset + word_len
            tokens.append(Token(word, word_offset))
        return tokens


    def tokenize(self, text: Text) -> List[Token]:
        if not self.case_sensitive:
            text = text.lower()
        numb = ''
        #print("********************text1************************"+ text)
        for s in text.split():
            if s.isdigit():
               numb = s
        print("text1***************************"+ text)
       # print("nuumber*************************"+ numb)
        text = trans(text)
        # print(numb)
        print("texttranslateld******************"+ text)
        text = text+" "+str(numb)
        # remove 'not a word character' if
        #print(text)
        if attribute != INTENT_ATTRIBUTE:
            words = re.sub(
            # there is a space or an end of a string after it
            r"[^\w#@&]+(?=\s|$)|"
            # there is a space or beginning of a string before it
            # not followed by a number
            r"(\s|^)[^\w#@&]+(?=[^0-9\s])|"
            # not in between numbers and not . or @ or & or - or #
            # e.g. 10'000.00 or blabla@gmail.com
            # and not url characters
            r"(?<=[^0-9\s])[^\w._~:/?#\[\]()@!$&*+,;=-]+(?=[^0-9\s])",
            " ",
               text,
            ).split()
        #text2 = ' '.join(words)
        #text2 = text2+" "+numb
        #words2 = text2.split(' ')
        #print("word2********")
        #print(words)
        #print("*******")
        #type(words)
        running_offset = 0
        tokens = []
        dicto={}
        print("**************words***************")
        print(words)
        with open("dict_banki.txt", 'r',encoding="utf8") as f:
             list = set(chain(*(line.split() for line in f if line)))
        #print ("DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD")
        for word in words:
            if word.isnumeric() :
                min_dist = word
                print("**************numberdetected*********"+word)
            else :
                for mot in list:
                    dicto[mot]=jellyfish.levenshtein_distance(mot, word)
                min_dist = min(dicto.keys(), key=(lambda k: dicto[k]))
            print(min_dist)
            word_corr = min_dist
            #print("word_corr"+word_corr)
            #print("word"+word_corr)
            word_offset = text.index(word, running_offset)
            word_len = len(word)
            running_offset = word_offset + word_len
            tokens.append(Token(word_corr, word_offset))
        return tokens

    def tokenize_arab(self, text: Text) -> List[Token]:
        if not self.case_sensitive:
            text = text.lower()
        
        # remove 'not a word character' if
        if attribute != INTENT_ATTRIBUTE:
            words = re.sub(
            # there is a space or an end of a string after it
            r"[^\w#@&]+(?=\s|$)|"
            # there is a space or beginning of a string before it
            # not followed by a number
            r"(\s|^)[^\w#@&]+(?=[^0-9\s])|"
            # not in between numbers and not . or @ or & or - or #
            # e.g. 10'000.00 or blabla@gmail.com
            # and not url characters
            r"(?<=[^0-9\s])[^\w._~:/?#\[\]()@!$&*+,;=-]+(?=[^0-9\s])",
            " ",
                text,
            ).split()
        #print(words)
        running_offset = 0
        tokens = []
        with open("dict_banki.txt", 'r',encoding="utf8") as f:
             list = set(chain(*(line.split() for line in f if line)))
        dict1= {}
        print(words)
        for word in words:
            print("SOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOS")
            for mot in list:
                dict1[mot]=jellyfish.levenshtein_distance(mot, word)
            if word.isnumeric():
                 min_dist = word
                 print("its a numbeeeeeeeer")
            else:
                 min_dist = min(dict1.keys(), key=(lambda k: dict1[k]))
            print(min_dist+"    mindiiiist")
            word_corr = min_dist
            word_offset = text.index(word, running_offset)
            word_len = len(word)
            running_offset = word_offset + word_len
            tokens.append(Token(word_corr, word_offset))
            
            
        self.add_cls_token(tokens, attribute)
        #print(tokens)
        return tokens

    

    



